{
 "metadata": {
  "name": ""
 },
 "nbformat": 3,
 "nbformat_minor": 0,
 "worksheets": [
  {
   "cells": [
    {
     "cell_type": "heading",
     "level": 1,
     "metadata": {},
     "source": [
      "14: Improving Quicksort"
     ]
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 1: Page 283"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates quick sort with median-of-three partitioning\n",
      "from random import randrange\t#for random numbers\n",
      "\n",
      "class ArrayIns:\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._theVect = []\t#list\n",
      "\n",
      "\tdef insert(self, value):\t#put element into array\n",
      "\t\tself._theVect.append(value)\t#insert it\n",
      "\n",
      "\tdef display(self):\t#displays array contents\n",
      "\t\tprint 'A=', self._theVect\t#display it\n",
      "\n",
      "\tdef quickSort(self):\t#sort array\n",
      "\t\tself.recQuickSort(0, len(self._theVect) - 1)\t#call recursive sort\n",
      "\n",
      "\tdef recQuickSort(self, left, right):\t#recursive sort\n",
      "\t\tsize = right-left+1\n",
      "\t\tif size <= 3:\t#manual sort if small\n",
      "\t\t\tself.manualSort(left, right)\n",
      "\t\telse:\t#quicksort if large\n",
      "\t\t\tmedian = self.medianOf3(left, right)\n",
      "\t\t\tpartition = self.partitionIt(left, right, median)\n",
      "\t\t\tself.recQuickSort(left, partition-1)\t#sort left side\n",
      "\t\t\tself.recQuickSort(partition+1, right)\t#sort right side\n",
      "\t#end recQuickSort()\n",
      "\n",
      "\tdef medianOf3(self, left, right):\n",
      "\t\tcenter = (left + right)/2\n",
      "\t\t#order left & center\n",
      "\t\tif self._theVect[left] > self._theVect[center]:\n",
      "\t\t\tself.swap(left, center)\n",
      "\t\t\t#order left & right\n",
      "\t\tif self._theVect[left] > self._theVect[right]:\n",
      "\t\t\tself.swap(left, right)\n",
      "\t\t\t#order center & right\n",
      "\t\tif self._theVect[center] > self._theVect[right]:\n",
      "\t\t\tself.swap(center, right)\n",
      "\n",
      "\t\tself.swap(center, right - 1)\t#put pivot on right\n",
      "\t\treturn self._theVect[right - 1]\t#return median value\n",
      "\t#end medianOf3()\n",
      "\n",
      "\tdef swap(self, dex1, dex2):\t#swap two elements\n",
      "\t\tself._theVect[dex1], self._theVect[dex2] = self._theVect[dex2], self._theVect[dex1]\n",
      "\t#end swap()\n",
      "\n",
      "\tdef partitionIt(self, left, right, pivot):\n",
      "\t\tleftMark = left\t#left (after+=)\n",
      "\t\trightMark = right - 1#right-1 (after -=)\n",
      "\t\twhile True:\n",
      "\t\t\tleftMark += 1\n",
      "\t\t\twhile self._theVect[leftMark] < pivot:\t#find bigger\n",
      "\t\t\t\t\tleftMark += 1\n",
      "\t\t\trightMark -= 1\n",
      "\t\t\twhile self._theVect[rightMark] > pivot:\t#find smaller\n",
      "\t\t\t\t\trightMark -= 1\n",
      "\n",
      "\t\t\tif leftMark >= rightMark:\t#if pointers cross,\n",
      "\t\t\t\tbreak\t#partition done\n",
      "\t\t\telse:\t#not crossed, so\n",
      "\t\t\t\tself.swap(leftMark, rightMark)\t#swap elements\n",
      "\t\t#end while(True)\n",
      "\t\tself.swap(leftMark, right - 1)\t#restore pivot\n",
      "\t\treturn leftMark\t#return pivot location\n",
      "\t#end paritionIt()\n",
      "\n",
      "\tdef manualSort(self, left, right):\n",
      "\t\tsize = right-left+1\n",
      "\t\tif size <= 1:\n",
      "\t\t\treturn\t#no sort necessary\n",
      "\t\tif size == 2:\n",
      "\t\t\tif self._theVect[left] > self._theVect[right]:\n",
      "\t\t\t\tself.swap(left, right)\n",
      "\t\t\treturn\n",
      "\t\telse:\t#size==3, so 3-sort left, center (right-1) & right\n",
      "\t\t\tif self._theVect[left] > self._theVect[right-1]:\n",
      "\t\t\t\tself.swap(left, right-1)\t#left, center\n",
      "\n",
      "\t\t\tif self._theVect[left] > self._theVect[right]:\n",
      "\t\t\t\tself.swap(left, right)\t#left, right\n",
      "\n",
      "\t\t\tif self._theVect[right-1] > self._theVect[right]:\n",
      "\t\t\t\tself.swap(right-1, right) \t#center, right\n",
      "\t#end manualSort()\n",
      "#end class ArrayIns\n",
      "\n",
      "arr = ArrayIns()\t#create the array\n",
      "\n",
      "for j in xrange(16):\t#fill array with\n",
      "\tn = randrange(0, 100)\t#random numbers\n",
      "\tarr.insert(n)\n",
      "arr.display()\t#display items\n",
      "arr.quickSort()\t#quicksort them\n",
      "arr.display()\t#display them again\n",
      "#end"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "A= [10, 6, 99, 26, 87, 43, 41, 48, 70, 21, 89, 65, 42, 48, 14, 7]\n",
        "A= [6, 7, 10, 14, 21, 26, 41, 42, 43, 48, 48, 65, 70, 87, 89, 99]\n"
       ]
      }
     ],
     "prompt_number": 1
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 2: Page 287"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates quick sort; uses insertion sort for cleanup\n",
      "from random import randrange\t#for randrange()\n",
      "\n",
      "class ArrayIns:\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._theArray = []\t#array theArray\n",
      "\n",
      "\tdef insert(self, value):\t#put element into array\n",
      "\t\tself._theArray.append(value)\t#insert it\n",
      "\n",
      "\tdef display(self):\t#displays array contents\n",
      "\t\tprint 'A=', self._theArray\t#display it\n",
      "\n",
      "\tdef quickSort(self):\t#sort the array\n",
      "\t\tself.recQuickSort(0, len(self._theArray) - 1)\n",
      "\t\t#self.insertionSort(0, len(self._theVect) - 1)\t#(another option)\n",
      "\n",
      "\tdef recQuickSort(self, left, right):\t#recursive sort\n",
      "\t\tsize = right-left+1\n",
      "\t\tif size < 10:\t#manual sort if small\n",
      "\t\t\tself.insertionSort(left, right)\n",
      "\t\telse:\t#quicksort if large\n",
      "\t\t\tmedian = self.medianOf3(left, right)\n",
      "\t\t\tpartition = self.partitionIt(left, right, median)\n",
      "\t\t\tself.recQuickSort(left, partition-1)\n",
      "\t\t\tself.recQuickSort(partition+1, right)\n",
      "\t#end recQuickSort()\n",
      "\n",
      "\tdef medianOf3(self, left, right):\n",
      "\t\tcenter = (left + right)/2\n",
      "\t\t#order left & center\n",
      "\t\tif self._theArray[left] > self._theArray[center]:\n",
      "\t\t\tself.swap(left, center)\n",
      "\t\t\t#order left & right\n",
      "\t\tif self._theArray[left] > self._theArray[right]:\n",
      "\t\t\tself.swap(left, right)\n",
      "\t\t\t#order center & right\n",
      "\t\tif self._theArray[center] > self._theArray[right]:\n",
      "\t\t\tself.swap(center, right)\n",
      "\n",
      "\t\tself.swap(center, right - 1)\t#put pivot on right\n",
      "\t\treturn self._theArray[right - 1]\t#return median value\n",
      "\t#end medianOf3()\n",
      "\n",
      "\tdef swap(self, dex1, dex2):\t#swap two elements\n",
      "\t\tself._theArray[dex1], self._theArray[dex2] = self._theArray[dex2], self._theArray[dex1]\n",
      "\t#end swap()\n",
      "\n",
      "\tdef partitionIt(self, left, right, pivot):\n",
      "\t\tleftMark = left\t#right of first element\n",
      "\t\trightMark = right - 1#left of pivot\n",
      "\t\twhile True:\n",
      "\t\t\tleftMark += 1\n",
      "\t\t\twhile self._theArray[leftMark] < pivot:\t#find bigger\n",
      "\t\t\t\t\tleftMark += 1\n",
      "\t\t\trightMark -= 1\n",
      "\t\t\twhile self._theArray[rightMark] > pivot:\t#find smaller\n",
      "\t\t\t\t\trightMark -= 1\n",
      "\n",
      "\t\t\tif leftMark >= rightMark:\t#if pointers cross,\n",
      "\t\t\t\tbreak\t#partition done\n",
      "\t\t\telse:\t#not crossed, so\n",
      "\t\t\t\tself.swap(leftMark, rightMark)\t#swap elements\n",
      "\t\t#end while(True)\n",
      "\t\tself.swap(leftMark, right - 1)\t#restore pivot\n",
      "\t\treturn leftMark\t#return pivot location\n",
      "\t#end paritionIt()\n",
      "\n",
      "\tdef insertionSort(self, left, right):\t#insertion sort\n",
      "\t\t#sorted on left of out\n",
      "\t\tfor out in range(left+1, right+1):\n",
      "\t\t\ttemp = self._theArray[out]\t#remove marked item\n",
      "\t\t\t#using In as in is reserved in Python\n",
      "\t\t\tIn = out\t#start shifts at out\n",
      "\t\t\t#until one is smaller,\n",
      "\t\t\twhile In > left and self._theArray[In-1] > temp:\n",
      "\t\t\t\tself._theArray[In] = self._theArray[In -1]\t#shift item to right\n",
      "\t\t\t\tIn -= 1#go left one position\n",
      "\t\t\tself._theArray[In] = temp\t#insert marked item\n",
      "\t\t#end for\n",
      "\t#end insertionSort()\n",
      "#end class ArrayIns\n",
      "\n",
      "arr = ArrayIns()\t#create array\n",
      "\n",
      "for j in xrange(16):\t#fill array with\n",
      "\tn = randrange(0, 100)\t#random numbers\n",
      "\tarr.insert(n)\n",
      "arr.display()\t#display items\n",
      "arr.quickSort()\t#quicksort them\n",
      "arr.display()\t#display them again\n",
      "#end"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "A= [29, 13, 61, 25, 80, 64, 70, 72, 40, 53, 78, 32, 73, 36, 72, 88]\n",
        "A= [13, 25, 29, 32, 36, 40, 53, 61, 64, 70, 72, 72, 73, 78, 80, 88]\n"
       ]
      }
     ],
     "prompt_number": 2
    }
   ],
   "metadata": {}
  }
 ]
}